'>Bambino-16
'>Robot R-Bambino
Sertxd("B16",cr)		'report program number

#PicAxe 20M2
#no_data

'Bambino-01	'Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02	'Test InfraRed input
'Bambino-02a	'Test Eye light values
'Bambino-02b	'Test Whisker light values and put in EEPROM
'Bambino-03	'Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-04	'Set servos to mid position	
'Bambino-05	'Calibrate servo mid positions and put in EEPROM.
'Bambino-06	'Introduce _iStand:- initialise with feet in mid position
'Bambino-07	'Set rollR
'Bambino-08	'Set rollL
'Bambino-09	'Check rollR, rollL
'Bambino-10	'Introduction of _Stand
'Bambino-11	'Investigate effect of rollspeed;	watch roll for all three speeds
'Bambino-12	'Investigate effect of rollspeed;	watch Roll and Stand for all three speeds
'Bambino-13	'Check paceFL paceFR;	Investigate effect of pacespeed
'Bambino-14	'Check Fd
'Bambino-15	'Test Rt, Lt
'Bambino-15a	'Test T2L Turn to Light, T2D Turn to Dark
'Bambino-16	'Test Bk


'Test Bk
'--------

'modified
'--------
'start:

'New
'---
'Bk
'_BkR
'_BkL

symbol servopace    =c.0 'left connector
symbol servoroll    =c.4 'right connector
symbol VoiceLed     =c.5 'low =>LED on 
symbol eyeLedL_     =c.2 'low =>LED on 
symbol eyeLedR_     =b.1 'low =>LED on
symbol whiskerLedL_ =c.3    'low =>whisker LED on
symbol whiskerLedR_ =b.3    'low =>whisker LED on
symbol iIRin        =c.6
symbol oIRout       =b.2

symbol spulse 	=b2
'symbol i 		=b3
symbol rollat 	=b4
symbol paceat 	=b5

symbol rollC	=150	'100 is roll to the left
symbol rollR      =rollC+15
symbol rollL      =rollC-15
symbol rollspeed  =b6   '4 is too fast, 0 won't move
	rollspeed =2  	'4 is too fast, 0 won't move
symbol paceC	=150	'100 is left foot back
symbol paceFR	=paceC-20	'Right foot forward
symbol paceFL	=paceC+20	'Left  foot forward
symbol paceFRmax	=100	'Right foot forward
symbol paceFLmax	=190	'Left  foot forward
symbol sframe     =20	'time between servo pulses
symbol pacespeed  =b7   '6 is about max for servos to keep up
	pacespeed =2   	'6 is about max for servos to keep up  




initialise:
	low eyeLedR_		'make output
	high eyeLedL_	'make output
	gosub _iStand
	

start:
	toggle eyeLedR_	'alter eyeR so we know program is running
	toggle eyeLedL_	'alter eyeR so we know program is running
	gosub Fd
	gosub Fd
	gosub Fd
	gosub Fd
	toggle eyeLedR_	'alter eyeR so we know program is running
	toggle eyeLedL_	'alter eyeR so we know program is running
	gosub Bk
	gosub Bk
	gosub Bk
	gosub Bk
	toggle eyeLedR_	'alter eyeR so we know program is running
	toggle eyeLedL_	'alter eyeR so we know program is running
	goto start


Fd:
sertxd (" Fd")
	if paceat<paceC then _FdL 'else _FdL
_FdR:
'sertxd ("_FdR")
	gosub _rollL
	gosub _RF
	gosub Stand
	return
_FdL:
'sertxd ("_FdL")
	gosub _rollR
	gosub _LF
	gosub Stand
	return
	

Bk:
sertxd (" Bk")
	if paceat<paceC then _BkR 'else _BkL
_BkL:
	gosub _rollR
	gosub _RF
	gosub Stand
	return
_BkR:
	gosub _rollL
	gosub _LF
	gosub Stand
	return


Rt:
	if paceat<paceC then gosub Fd	'need left foot forward
	gosub _RF
	return
	
Lt:
	if paceat>paceC then gosub Fd	'need right foot forward
	gosub _LF
	return

_RF:
'sertxd ("_RF")
	for spulse=paceat to paceFR step -pacespeed
	  paceat =spulse
	  pulsout servopace,paceat	'pulse servo
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
_LF:
'sertxd ("_LF")
	for spulse=paceat to paceFL step pacespeed
	  paceat =spulse
	  pulsout servopace,paceat	'pulse servo
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 

Stand:	'stand with both feet flat
sertxd (" Sd")
	if rollat<rollC then _StandR 'else _StandL
_StandL:
'sertxd ("_SL")
	for spulse=rollat to rollC step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
_StandR:
'sertxd ("_SR")
	for spulse=rollat to rollC step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 


_rollL:
'sertxd ("_rL")
	for spulse=rollat to rollL step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
	 
_rollR:
'sertxd ("_rR")
	for spulse=rollat to rollR step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 

_iStand:
'initialise with feet in mid position
	for spulse=0 to 10
	  pulsout servopace,paceC	'pulse servo paceC
	  pulsout servoroll,rollC	'pulse servo rollC
	  pause 70				'pause 70ms - do it slowly
	 next spulse
	rollat =rollC
	paceat =paceC 
	return 