'>Bambino-18
'>Robot R-Bambino
Sertxd("B18",cr)		'report program number

#PicAxe 20M2
#no_data

'Bambino-01	'Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02	'Test InfraRed input
'Bambino-02a	'Test Eye light values
'Bambino-02b	'Test Whisker light values
'Bambino-03	'Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-04	'Set servos to mid position	
'Bambino-05	'Calibrate servo mid positions.
'Bambino-06	'Introduce _iStand:- initialise with feet in mid position
'Bambino-07	'Set rollR
'Bambino-08	'Set rollL
'Bambino-09	'Check rollR, rollL
'Bambino-10	'Introduction of _Stand
'Bambino-11	'Investigate effect of rollspeed;	watch roll for all three speeds
'Bambino-12	'Investigate effect of rollspeed;	watch Roll and Stand for all three speeds
'Bambino-13	'Check paceFL paceFR;	Investigate effect of pacespeed
'Bambino-14	'Check Fd
'Bambino-15	'Test Rt, Lt
'Bambino-15a	'Test T2L Turn to Light, T2D Turn to Dark
'Bambino-16	'Test Bk
'Bambino-17	'Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
            	'Introduction of ACT parameter 'Ado'
'Bambino-17a 'Demo routine            	
'Bambino-18	'Walk Fd with obstacle avoidance using eyes from 02a


            	
'Walk Fd with obstacle avoidance using eyes from 02a
'---------------------------------------------------            	
            	
'modified
'--------
'all variable moved up by 2 bytes to leave all the bit variables spare for flags, etc
'all variable moved up by another byte for temp
'start
'Fd	for defaultB
'Bk	for defaultB
'Rt	for defaultB
'Lt	for defaultB


'New
'---
'beep150
'EyesON
'defaultB  (defaultBehaviour) 1=use default allows Fd, Bk, Rt, Lt to use specific speed settings
'B_turn
'lightL
'lightR
'temp
'obsdetectL
'obsdetectR
'QEwhiskerL		Query Eye whisker Left
'QEwhiskerR		Query Eye whisker Right


symbol servopace    =c.0	'left connector
symbol servoroll    =c.4	'right connector
symbol VoiceLed_    =c.5      'low =>LED on 
symbol eyeLedL_     =c.2      'low =>LED on 
symbol eyeLedR_     =b.1      'low =>LED on
symbol whiskerLedL_ =c.3      'low =>whisker LED on
symbol whiskerLedR_ =b.3      'low =>whisker LED on
symbol eyeR         =c.7		  	
symbol eyeL         =c.1		  	
symbol iIRin        =c.6
symbol oIRout       =b.2

'symbol general 	 =b0
symbol B_flags     =b3
symbol defaultB    =bit31	'defaultBehaviour 1=use default
symbol temp        =b4
symbol spulse 	 =b5
symbol iA 		 =b6
symbol rollat 	 =b7
symbol paceat 	 =b8

symbol rollC  	 =150	'100 is roll to the left
symbol rollR       =rollC+15
symbol rollL       =rollC-15
symbol rollspeed   =b9   '4 is too fast, 0 won't move
	rollspeed =1  	'4 is too fast, 0 won't move
symbol paceC	 =150	'100 is left foot back
symbol paceFR	 =paceC-20	'Right foot forward
symbol paceFL 	 =paceC+20	'Left  foot forward
symbol paceFRmax 	 =100	'Right foot forward
symbol paceFLmax	 =190	'Left  foot forward
symbol sframe      =20	'time between servo pulses
symbol pacespeed   =b10   '6 is about max for servos to keep up
	pacespeed =2   	'6 is about max for servos to keep up  
symbol Ado		 =b11	'parameter for ACTs
symbol obstacle    =b12  '%11 bitmap of obstacles  %LeftRight
symbol lightL      =b13  'light level Left
symbol lightR      =b14  'light level Right
'depending on the sensors obsdetectL and obsdetectR may need to be different
symbol obsdetectL	 =120	'scaled light level difference for obstacle
symbol obsdetectR	 =120	'scaled light level difference for obstacle



initialise:
	low eyeLedR_	'make output LED on
	low eyeLedL_	'make output LED on
	gosub _iStand
	defaultB =1		'defaultBehaviour On
	
start:


	obstacle =0
	gosub EyesOFF
QEwhiskerL:
	readadc eyeL,lightL
	low eyeLedL_			'eyeL on
	readadc eyeL,temp
	high  eyeLedL_			'eyeL off
	if lightL>temp then			'why this happens I don't know
	  temp =lightL				
	 endif	
	temp =temp -lightL *256 /temp 'find difference and scale it
	sertxd("L=",#temp," ")
	if temp<obsdetectL then QEwhiskerR	'ignore
	obstacle =obstacle or %10 

QEwhiskerR:
	readadc eyeR,lightR
	low eyeLedR_			'eyeR on
	readadc eyeR,temp
	high  eyeLedR_			'eyeR off
	if lightR>temp then		'why this happens I don't know
	  temp =lightR				
	 endif	
	temp =temp -lightR *256 /temp 'find difference and scale it
	sertxd("R=",#temp,cr)
	if temp<obsdetectR then Walk	'ignore
	obstacle =obstacle or 1 
	

Walk:	
	gosub B_fast
	b0 =obstacle 			'to use bits
	if bit0=0 then
	  low eyeLedR_
	 endif 
	if bit1=0 then
	  low eyeLedL_
	 endif 
	on obstacle gosub Fd,Lt,Rt,Bk 
	goto start                    'loop back to start


'-----------------------------------------
'Acts
'----

RockAdo:
	for iA=1 to Ado  
 	  gosub _rollR
	  gosub _rollL
	 next iA 
	return
	
FdAdo:
	for iA=1 to Ado 
	  gosub Fd
	 next iA 
	return
	
BkAdo:
	for iA=1 to Ado 
	  gosub Bk
	 next iA 
	return
	

'-----------------------------------------
'Behaviours
'----------
B_fast:
	rollspeed =3
	pacespeed =6 
	return
	
B_turn:	
	rollspeed =1	'slow so foot doesn't bounce
	pacespeed =5 
	return	
'-----------------------------------------
'Actions
'-------

beep150:
	sound VoiceLed_,(150,10)
	return

EyesOFF:
	high eyeLedR_
	high eyeLedL_
	return
	
EyesON:
	low eyeLedR_
	low eyeLedL_
	return
		

Fd:
sertxd (" Fd")
	if defaultB=1 then gosub B_fast
	if paceat<paceC then _FdL 'else _FdL
_FdR:
'sertxd ("_FdR")
	gosub _rollL
	gosub _RF
	gosub Stand
	return
_FdL:
'sertxd ("_FdL")
	gosub _rollR
	gosub _LF
	gosub Stand
	return
	

Bk:
sertxd (" Bk")
	if defaultB=1 then gosub B_fast
	if paceat<paceC then _BkR 'else _BkL
_BkL:
	gosub _rollR
	gosub _RF
	gosub Stand
	return
_BkR:
	gosub _rollL
	gosub _LF
	gosub Stand
	return


Rt:
	if paceat<paceC then gosub Fd	'need left foot forward
	if defaultB=1 then gosub beep150
	if defaultB=1 then gosub B_turn
	gosub _RF
	return
	
Lt:
	if paceat>paceC then gosub Fd	'need right foot forward
	if defaultB=1 then gosub beep150
	if defaultB=1 then gosub B_turn
	gosub _LF
	return

_RF:
'sertxd ("_RF")
	for spulse=paceat to paceFR step -pacespeed
	  paceat =spulse
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pulsout servopace,paceat	'pulse servo
	  pause sframe
	 next spulse
	return 
_LF:
'sertxd ("_LF")
	for spulse=paceat to paceFL step pacespeed
	  paceat =spulse
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pulsout servopace,paceat	'pulse servo
	  pause sframe
	 next spulse
	return 
	

Stand:	'stand with both feet flat
sertxd (" Sd")
	if rollat<rollC then _StandR 'else _StandL
_StandL:
'sertxd ("_SL")
	for spulse=rollat to rollC step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
_StandR:
'sertxd ("_SR")
	for spulse=rollat to rollC step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 


_rollL:
'sertxd ("_rL")
	for spulse=rollat to rollL step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
	 
_rollR:
'sertxd ("_rR")
	for Spulse=rollat to rollR step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 

_iStand:
'initialise with feet in mid position
	for spulse=0 to 10
	  pulsout servopace,paceC	'pulse servo paceC
	  pulsout servoroll,rollC	'pulse servo rollC
	  pause 70				'pause 70ms - do it slowly
	 next spulse
	rollat =rollC
	paceat =paceC 
	return 
'-----------------------------------------
